UnparametricZRing< _Element > Class Template Reference

Generic Class ZRing. More...

`#include <zring.h>`

## Public Member Functions

Comparison Predicates
bool | areEqual (const Element &x, const Element &y) const
| x == y
Arithmetic Operations
The first argument is set and is also the return value.
Element & | add (Element &x, const Element &y, const Element &z) const
| x := y + z
Element & | sub (Element &x, const Element &y, const Element &z) const
| x := y - z
Element & | mul (Element &x, const Element &y, const Element &z) const
| x := y*z
Element & | div (Element &x, const Element &y, const Element &z) const
| x := y/z
Element & | mod (Element &x, const Element &y, const Element &z) const
| x := y mod z
Element & | neg (Element &x, const Element &y) const
| x := -y
Element & | inv (Element &x, const Element &y) const
| x := 1/y
Element & | axpy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := a*x + y
Element & | axpyin (Element &z, const Element &a, const Element &x) const
| z := a*x + z
Element & | axmy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := a*x - y
Element & | axmyin (Element &z, const Element &a, const Element &x) const
| z := a*x - z
Element & | maxpy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := y - a*x
Element & | maxpyin (Element &z, const Element &a, const Element &x) const
| z := z - a*x
Inplace Arithmetic Operations
The first argument is modified and the result is the return value.
Element & | addin (Element &x, const Element &y) const
| x := x + y
Element & | subin (Element &x, const Element &y) const
| x := x - y
Element & | mulin (Element &x, const Element &y) const
| x := x*y
Element & | divin (Element &x, const Element &y) const
| x := x/y
Element & | modin (Element &x, const Element &y) const
| x := x mod y
Element & | negin (Element &x) const
| x := -x
Element & | invin (Element &x) const
| x := 1/x
Input/Output Operations
std::ostream & | write (std::ostream &os, std::string F) const
| Read field.
std::istream & | read (std::istream &is) const
| Read field.

## Detailed Description

template<class _Element>
class Givaro::UnparametricZRing< _Element >

Generic Class ZRing.

Ring of integers, using the unparametric _Element base type. Provide unparametric with domain features ZRing<Element> is a sugar name for UnparametricZRing<Element> Also, there is a specialization, below, for ZRing<Integer>

## Member Function Documentation

## write()

template<class _Element>

std::ostream & write | ( | std::ostream & | os,
|  | std::string | F ) const

inline inherited

Read field.

Returns
  input stream from which field is read.

Parameters

  is | input stream from which field is read.

## read()

template<class _Element>

std::istream & read | ( | std::istream & | is | ) | const

inline inherited

Read field.

Returns
  input stream from which field is read.

Parameters

  is | input stream from which field is read.

The documentation for this class was generated from the following file:

- zring.h